#include "IoState.h"
#include "IoObject.h"

IoObject *IoIPAddress_proto(void *state);
IoObject *IoEventManager_proto(void *state);
IoObject *IoDNS_proto(void *state);
IoObject *IoEvent_proto(void *state);
IoObject *IoSocket_proto(void *state);

void IoSocketInit(IoObject *context)
{
	IoState *self = IoObject_state((IoObject *)context);

	IoObject_setSlot_to_(context, SIOSYMBOL("IPAddress"), IoIPAddress_proto(self));

	IoObject_setSlot_to_(context, SIOSYMBOL("EventManager"), IoEventManager_proto(self));

	IoObject_setSlot_to_(context, SIOSYMBOL("DNS"), IoDNS_proto(self));

	IoObject_setSlot_to_(context, SIOSYMBOL("Event"), IoEvent_proto(self));

	IoObject_setSlot_to_(context, SIOSYMBOL("Socket"), IoSocket_proto(self));

}
